#region usings
using System;
using System.Collections.Generic;
using System.Text;
using System.ComponentModel.Composition;
using VVVV.PluginInterfaces.V2;
using VVVV.Utils.VMath;
using VVVV.Core.Logging;
#endregion usings

namespace VVVV.Nodes
{
	#region PluginInfo
	[PluginInfo(Name = "DissPress", Category = "String", Help = "dissociated press", Tags = "")]
	#endregion PluginInfo
	public class StringDissPressNode : IPluginEvaluate
	{
		#region fields & pins
		[Input("Input", DefaultString = "some text")]
		public IDiffSpread<string> SInput;

		[Input("Chunk", DefaultValue = 4)]
		public IDiffSpread<int> IChunk;

		[Input("Overlap", DefaultValue = 3)]
		public IDiffSpread<int> ILap;

		[Input("Steps", DefaultValue = 100)]
		public IDiffSpread<int> IStep;

		[Output("Output")]
		public ISpread<string> SOutput;

		[Output("Not Found")]
		public ISpread<int> IOutSkip;

		int[] iPos, iLen, iCh, cbad;

		[Import()]
		public ILogger FLogger;
		#endregion fields & pins

		//called when data for any output pin is requested
		public void Evaluate(int SpreadMax)
		{
			SOutput.SliceCount = 1;
			IOutSkip.SliceCount = SpreadMax;
			IStep.SliceCount = 1;
			this.iPos = new int[SpreadMax];
			this.iLen = new int[SpreadMax];
			this.iCh = new int[SpreadMax];
			this.cbad = new int[SpreadMax];

			string sLap="", sChnk="", sOver=""; // , sMix="";
			int iOver, iFnd=0;
			bool search = false;
			
			for(int j=0; j<SpreadMax; j++)
			{
				iPos[j] = 0;
				cbad[j] = 0;
				iLen[j] = SInput[j].Length;
				iCh[j] = IChunk[j] + ILap[j];
			}
// ========================================================
			if (SInput.IsChanged || IChunk.IsChanged || ILap.IsChanged || IStep.IsChanged ) {
				SOutput[0] = "";
	
				int i=0, j=0;
				for (int ii=0; ii<IStep[0]; ii++) {
					i = i%SpreadMax;
					iPos[i] %= iLen[i];
				
// search for pattern from pointer, then from start; if no, go next file
					if (search) {
						for (int k=0; (k<SpreadMax) ; k++) {
							j = (i+k)%SpreadMax;
							iFnd = SInput[j].IndexOf(sLap, iPos[j]);
							if (iFnd < 0)
								iFnd = SInput[j].IndexOf(sLap, 0);
							if (iFnd >= 0) {
								iPos[j] = iFnd + ILap[j];
								i = j;
								break;
							} else {
								if (k == SpreadMax-1)
									cbad[i] +=1;
							}
						}						
					}
// check if overflow, read chunk, move pointer
					iPos[i] %= iLen[i];
					iOver = iPos[i] + iCh[i] - iLen[i];
					if ( iOver <= 0) {
						sChnk = SInput[i].Substring(iPos[i], iCh[i]);
						iPos[i] += iCh[i];
					}
					else {
						sOver = SInput[i] + SInput[i].Substring(0, iCh[i]);
						sChnk = sOver.Substring(iPos[i], iCh[i]);
						iPos[i] = iOver;
					}
// read pattern, add chunk to mix
					sLap = sChnk.Substring(IChunk[i], ILap[i]);
					search = true;

					IOutSkip[i] = cbad[i];
					SOutput[0] += sChnk;
					i += 1;
				}
			//FLogger.Log(LogType.Debug, "Logging to Renderer (TTY)");
			}	
		}
	}
}
